Attribute VB_Name = "Module1"
Option Explicit

Global LocalHostName As String
Global LocalIP As String

Global Links() As String
Global LinkCount As Integer
Global MaxLinks As Integer

Global maxlength As Long

Global Const SND_SYNC = &H0
Global Const SND_ASYN = &H1
Global Const SND_NODEFAULT = &H2
Global Const SND_LOOP = &H8
Global Const SND_NOSTOP = &H10

Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
 
Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
Global Const flags = SWP_NOMOVE Or SWP_NOSIZE
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2

Declare Function GetDC Lib "user32" (ByVal hWnd As Integer) As Integer
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Declare Function FlashWindow Lib "user32" (ByVal hWnd As Long, ByVal bInvert As Long) As Long
Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Global History(25) As String
Global HistPoint As Integer
Global HistLast As Integer

Type IRCServer
    Name As String
    hostname As String
    Port As Long
    Group As String
End Type

Type DCCHeader
    bytes() As Byte
End Type

Type UserInfo
    Nick As String
    Nick2 As String
    RN As String
    EMail As String
End Type

Global CR
Public MLIRCDate
Public MLIRCVer As String

Public UI As UserInfo
Public LastRequest As String

Public IRCServers() As IRCServer
Public ServerCount As Integer

Public Hosts As New Collection
Public TCPs As New Collection

Public DCCs As New Collection
Public DCCts As New Collection

'Icon transfer vars
Public SFile As Integer
Public SLength As Double
Public SBytes() As Byte

Public GFile As Integer
Public GLength As Integer
Public GBytes(3) As Byte

Public AliasesC As New Collection
Public UsersC As New Collection
Public GroupsC As New Collection
Public CommandsC As New Collection

Global KillNick As String
Sub OldAddText(TextBox As Control, IText As String, Color As Long, Bold As Boolean)
    TextBox.SelColor = Color
    TextBox.SelBold = Bold
    If Val(getsetting("MLIRC", "Options", "show Time", "0")) = 1 Then IText = Format(Now, "hh:mm:ss") & " " & IText
    TextBox.SelText = IText
    TextBox.SelStart = Len(TextBox.Text)
End Sub


Function Alias(Command As String, Host As String, Channel As String)
    Dim Command2 As String, Ali As String, AString As String, Para As String, Args() As String, ArgC As Integer, Arg As Integer
    
    If Trim(Command) <> "" Then
        If InStr(1, Command, " ") Then
            Ali = UCase(Left(Command, InStr(1, Command, " ") - 1))
        Else
            Ali = UCase(Command)
        End If
        On Error GoTo AFehler
        AString = AliasesC.Item(Ali)
        On Error GoTo 0
        ArgC = 0
        If InStr(1, Command, " ") Then Para = Mid(Command, InStr(1, Command, " "))
        Do While InStr(1, Command, " ")
            ReDim Preserve Args(ArgC)
            Args(ArgC) = Left(Command, InStr(1, Command, " ") - 1)
            ArgC = ArgC + 1
            Command = Right(Command, Len(Command) - InStr(1, Command, " "))
        Loop
        ReDim Preserve Args(ArgC)
        Args(ArgC) = Command
        Command = " " & Right(AString, Len(AString) - InStr(1, AString, " ")) & " "
        
        If InStr(1, Command, "$chann", 1) Then
            Command = Left(Command, InStr(1, Command, "$chann", 1) - 1) & Channel & Right(Command, Len(Command) - InStr(1, Command, "$chann", 1) - 5)
        End If
        If InStr(1, Command, "$host", 1) Then
            Command = Left(Command, InStr(1, Command, "$host", 1) - 1) & Host & Right(Command, Len(Command) - InStr(1, Command, "$host", 1) - 4)
        End If
        If InStr(1, Command, "$me", 1) Then
            Command = Left(Command, InStr(1, Command, "$me", 1) - 1) & Hosts(Host).Nick & Right(Command, Len(Command) - InStr(1, Command, "$me", 1) - 2)
        End If
        
        If InStr(1, Command, "$param", 1) Then
            Command = Left(Command, InStr(1, Command, "$param", 1) - 1) & Trim(Para) & Right(Command, Len(Command) - InStr(1, Command, "$param", 1) - 5)
        End If
        
        If InStr(1, Command, "$") = 0 Or InStr(1, Command, " ") = 0 Then GoTo KeinAlias
        Do While Val(Mid(Command, InStr(1, Command, "$") + 1, InStr(InStr(1, Command, "$"), Command, " ") - InStr(1, Command, "$"))) > 0
            Arg = Val(Mid(Command, InStr(1, Command, "$") + 1, InStr(InStr(1, Command, "$"), Command, " ") - InStr(1, Command, "$")))
            If Arg <= ArgC Then
                Command = Left(Command, InStr(1, Command, "$") - 1) & Args(Arg) & Right(Command, Len(Command) - InStr(InStr(1, Command, "$"), Command, " ") + 1)
            Else
                Command = Left(Command, InStr(1, Command, "$") - 1) & Right(Command, Len(Command) - InStr(InStr(1, Command, "$"), Command, " ") + 1)
            End If
            If InStr(1, Command, "$") = 0 Or InStr(1, Command, " ") = 0 Then Exit Do
        Loop
KeinAlias:
        Command = " " & Command & " "
        If InStr(1, Command, "$chann", 1) Then
            Command = Left(Command, InStr(1, Command, "$chann", 1) - 1) & Channel & Right(Command, Len(Command) - InStr(1, Command, "$chann", 1) - 5)
        End If
        If InStr(1, Command, "$host", 1) Then
            Command = Left(Command, InStr(1, Command, "$host", 1) - 1) & Host & Right(Command, Len(Command) - InStr(1, Command, "$host", 1) - 4)
        End If
        If InStr(1, Command, "$me", 1) Then
            Command = Left(Command, InStr(1, Command, "$me", 1) - 1) & Hosts(Host).Nick & Right(Command, Len(Command) - InStr(1, Command, "$me", 1) - 2)
        End If
        Command = Trim(Command)
        Alias = Command
        Exit Function
    End If
    Alias = Command
    Exit Function

AFehler:
    If Err = 5 Then
        Resume KeinAlias
    End If
    MsgBox ("Alias " & Err & " " & Error$)
    Resume Next
End Function


Function CleanCR(inp As String)
    Dim pos
    
    If Right(inp, 1) = Chr$(10) Then
        inp = Left(inp, Len(inp) - 1)
    End If
    
    If Right(inp, 1) = Chr$(13) Then
        inp = Left(inp, Len(inp) - 1)
    End If
    
    pos = InStr(1, inp, Chr$(13))
    If pos > 0 Then
        inp = Left(inp, pos - 1) & Right(inp, Len(inp) - pos)
    End If
    
    pos = InStr(1, inp, Chr$(10))
    If pos > 0 Then
        inp = Left(inp, pos - 1) & Right(inp, Len(inp) - pos)
    End If
    
    CleanCR = inp
End Function


Function CommandLine(inp As String, Server As String, Channel As String)
    Dim Name As String, Soundfile As String, erg
    inp = CleanCR(inp)
    
    CommandLine = Alias(inp, Server, Channel)
    
    If UCase(Left(inp, 10)) = "/PLAYSOUND" Then
        Soundfile = Trim(Mid(inp, 11))
        CommandLine = ""
        If Dir(Soundfile) <> "" Then
            erg = PlaySound(Soundfile, 0, SND_ASYN)
            CommandLine = "Played " & Soundfile
        End If
        If Dir(App.Path & "\" & Soundfile) <> "" Then
            erg = PlaySound(App.Path & "\" & Soundfile, 0, SND_ASYN)
            CommandLine = "Played " & App.Path & "\" & Soundfile
        End If
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/QUIT" Then
        Unload Hosts(Server).Window
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/KILL" Then
        'debug.print "Kill "; Trim(Mid(inp, 6))
        KillNick = Trim(Mid(inp, 6))
        MDIForm1.Timer2.Interval = 1000
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/STOP" Then
        KillNick = ""
        MDIForm1.Timer2.Interval = 0
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/JOIN" Then
        inp = Right(inp, Len(inp) - 1)
        Hosts(Server).SendData inp & Chr$(10)
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 4)) = "/DCC" Then
        inp = Trim(Right(inp, Len(inp) - 4))
        If InStr(1, inp, " ") Then
            Name = Left(inp, InStr(1, inp, " ") - 1)
            inp = Right(inp, Len(inp) - InStr(1, inp, " "))
        End If
        
        SendDCCFile Name, inp, Server
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/CTCP" Then
        inp = Trim(Right(inp, Len(inp) - 5))
        If InStr(1, inp, " ") Then
            Name = Left(inp, InStr(1, inp, " ") - 1)
            inp = Right(inp, Len(inp) - InStr(1, inp, " "))
        End If
        
        SendCTCP Name, Server, inp
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 6)) = "/SOUND" Then
        inp = Trim(Right(inp, Len(inp) - 6))
        If InStr(1, inp, " ") Then
            Name = Left(inp, InStr(1, inp, " ") - 1)
            inp = Right(inp, Len(inp) - InStr(1, inp, " "))
        End If
        
        Hosts(Server).SendData "PRIVMSG " & Name & " :" & Chr$(1) & "SOUND " & inp & Chr$(1) & Chr$(10)
        CommandLine = ""
        inp = ""
    End If
    
    If UCase(Left(inp, 8)) = "/ONOTICE" And Channel <> "" Then
        CommandLine = inp
        inp = Trim(Mid(inp, 10))
        For erg = 1 To Hosts(Server).Channels(Channel).Window.List1.ListItems.Count
            If Left(Hosts(Server).Channels(Channel).Window.List1.ListItems(erg), 1) = "@" Then
                Hosts(Server).SendData "NOTICE " & Mid(Hosts(Server).Channels(Channel).Window.List1.ListItems(erg), 2) & " :" & Left(inp, InStr(1, inp, " ")) & Trim(Right(inp, Len(inp) - InStr(1, inp, " "))) & Chr$(10)
            End If
        Next erg
        inp = ""
    End If
    
    If UCase(Left(inp, 4)) = "/MSG" Then
        inp = Trim(Right(inp, Len(inp) - 4))
        CommandLine = "->" & Left(inp, InStr(1, inp, " ")) & ": " & Trim(Right(inp, Len(inp) - InStr(1, inp, " ")))
        Hosts(Server).SendData "PRIVMSG " & Left(inp, InStr(1, inp, " ")) & ":" & Trim(Right(inp, Len(inp) - InStr(1, inp, " "))) & Chr$(10)
        inp = ""
    End If
    
    If UCase(Left(inp, 5)) = "/AWAY" Then
        inp = Trim(Right(inp, Len(inp) - 5))
        Hosts(Server).SendData "AWAY " & ":" & inp & Chr$(10)
        inp = ""
    End If
    
    If UCase(Left(inp, 3)) = "/ME" Then
        inp = Trim(Right(inp, Len(inp) - 3))
        Hosts(Server).SendData "PRIVMSG " & Channel & " :" & Chr$(1) & "ACTION " & inp & Chr$(1) & Chr$(10)
        CommandLine = "* " & Hosts(Server).Nick & " " & inp
        inp = ""
    End If
    
    If Left(inp, 1) = "/" Then
        Hosts(Server).SendData Right(inp, Len(inp) - 1) & Chr$(10)
        CommandLine = ""
        inp = ""
    End If
    
    If inp <> "" And Channel <> "" Then
        Hosts(Server).SendData "PRIVMSG " & Channel & " :" & inp & Chr$(10)
        CommandLine = Hosts(Server).Nick & "> " & inp
    End If
End Function
Sub ConnectTo(i As Integer)
    Dim NH As New IRCHost
    Dim NW As New MainFrm
    Dim n As Integer
    
    n = 0
    
    On Error GoTo HFehler
    Hosts.Add NH, UCase(IRCServers(i).hostname & ":" & IRCServers(i).Port & "/" & Trim(Str(n)))
    On Error GoTo 0
    
    'debug.print UI.Nick
    NH.Nick = UI.Nick
    NH.Name = IRCServers(i).hostname
    NH.Port = IRCServers(i).Port
    
    Set NH.Window = NW
    
    NW.Tag = IRCServers(i).hostname & ":" & IRCServers(i).Port & "/" & Trim(Str(n))
    NW.Caption = IRCServers(i).hostname & ":" & IRCServers(i).Port & "/" & Trim(Str(n))
    NW.Show
    Exit Sub
    
HFehler:
    If Err = 457 Then
        n = n + 1
        Resume
    End If
    
    MsgBox ("Hosterror: " & Err & " " & Error$)
    Resume Next
    
End Sub


Sub EventHappen(myEvent As String, Text As String, User As String, Channel As String, Host As String)
    Dim i As Integer, level As Integer, Group As String, Nick As String, WS As String, CName As String
    
    'If Event <> "TEXT" Then IconForm.text1.seltext = Event & " " & User & " " & Channel & CR
    'IconForm.text1.SelStart = Len(IconForm.text1.Text)
    
    For i = 1 To UsersC.Count
        If User Like Left(UsersC(i), InStr(1, UsersC(i), ":") - 1) Then
            Group = Mid(UsersC(i), InStr(1, UsersC(i), ":") + 1)
            On Error GoTo LevelError
            level = GroupsC(UCase(Group))
            On Error GoTo 0
            'IconForm.text1.seltext = Group & " Level:" & Level & CR
            'IconForm.text1.SelStart = Len(IconForm.text1.Text)
        End If
    Next i
    
    For i = 1 To CommandsC.Count
        If UCase(Left(CommandsC(i), InStr(1, CommandsC(i), Chr$(9)) - 1)) = myEvent Then
            WS = Mid(CommandsC(i), InStr(1, CommandsC(i), Chr$(9)) + 1)
            If Left(Trim(WS), 1) = "#" Then WS = Mid(WS, 2)
            If Left(Channel, 1) = "#" Then
                CName = Mid(Channel, 2)
            Else
                CName = Channel
            End If
            Debug.Print User
            Debug.Print "CH: "; UCase(Channel); " "; UCase(Left(WS, InStr(1, WS, Chr$(9)) - 1))
            If UCase(CName) Like UCase(Left(WS, InStr(1, WS, Chr$(9)) - 1)) Then
                WS = Mid(WS, InStr(1, WS, Chr$(9)) + 1)
                Debug.Print "L: "; Val(Trim(UCase(Left(WS, InStr(1, WS, Chr$(9)) - 1)))), level
                If Trim(Str(level)) Like Trim(Left(WS, InStr(1, WS, Chr$(9)) - 1)) Then
                    WS = " " & Mid(WS, InStr(1, WS, Chr$(9)) + 1) & " "
                    Nick = Left(User, InStr(1, User, "!") - 1)
                    If InStr(1, WS, "$nick", 1) Then
                        WS = Left(WS, InStr(1, WS, "$nick", 1) - 1) & Nick & Mid(WS, InStr(1, WS, "$nick", 1) + 5)
                    End If
                    If InStr(1, WS, "$chann", 1) Then
                        WS = Left(WS, InStr(1, WS, "$chann", 1) - 1) & Channel & Mid(WS, InStr(1, WS, "$chann", 1) + 6)
                    End If
                    OldAddText Hosts(Host).Window.OutPut, "Event: " & CommandLine(Trim(WS), Host, Channel) & vbCrLf, Val(getsetting("MLIRC", "Colors", "Event", Str(&HFF&))), False
                    Debug.Print WS
                End If
            End If
        End If
    Next i
    Exit Sub

LevelError:
    level = 0
    Resume Next
    
End Sub

Function IconInCache(pname As String, plength As Long, pdate As String)
    Dim CF As Long, Ins As String, i As Integer
    CF = FreeFile
    
    i = 1
    Open App.Path & "\icon\icache.dat" For Binary As CF Len = 48
    Do While Not EOF(CF)
        Ins = Space(47)
        Get CF, i, Ins
        'debug.print Ins
        If Ins = "" Then Exit Do
        If Trim(Mid(Ins, 9, 15)) = pname And Val(Mid(Ins, 24, 10)) = plength And Trim(Mid(Ins, 34, 15)) = pdate Then
            IconInCache = Left(Ins, 8)
            Close CF
            Exit Function
        End If
        i = i + 47
    Loop
    Close CF
    IconInCache = ""
End Function

Function IP2String(InIP As String)
    Dim IPstring As String
    Dim IP As Double
    
    IPstring = InIP
    IP = Val(Left(IPstring, InStr(1, IPstring, ".") - 1)) * 16777216
    IPstring = Right(IPstring, Len(IPstring) - InStr(1, IPstring, "."))
    IP = IP + Val(Left(IPstring, InStr(1, IPstring, ".") - 1)) * 65536
    IPstring = Right(IPstring, Len(IPstring) - InStr(1, IPstring, "."))
    IP = IP + Val(Left(IPstring, InStr(1, IPstring, ".") - 1)) * 256
    IPstring = Right(IPstring, Len(IPstring) - InStr(1, IPstring, "."))
    IP2String = IP + Val(IPstring)
End Function



Sub SetMode(AData As String, WorkData As String, Host As String, OutPut As Form)
    
    Dim Mode As String, onc As String
    Dim UName As String, Chan As String
    Dim pos As Integer, i As Integer
    
    If InStr(1, AData, "!") Then
        UName = Mid(AData, 2, InStr(1, AData, "!") - 2)
    Else
        UName = Mid(AData, 2, InStr(1, AData, " ") - 2)
    End If
    
    pos = InStr(1, AData, " ")
    pos = InStr(pos + 1, AData, " ")
    Chan = Mid(AData, pos + 1, InStr(pos + 1, AData, " ") - pos - 1)
    pos = InStr(pos + 1, AData, " ")
    
    If WorkData <> "" Then
        Mode = Trim(WorkData)
        onc = Chan
        OutPut.AddText "MODE: " & UName & " sets " & Mode & " on " & onc & CR, Val(getsetting("MLIRC", "Colors", "Mode", Str(&HFF&))), True
        EventHappen "MODE", Mode, Mid(AData, 2, InStr(1, AData, " ") - 2), "", Host
    Else
       Mode = Trim(Mid(AData, pos + 1))
        
        onc = Chan
        
        If UCase(Mid(Mode, 2, 1)) = "V" Or UCase(Mid(Mode, 2, 1)) = "O" Then
            Debug.Print AData
            pos = InStr(pos + 1, AData, " ")
            'onc = Mid(AData, pos + 1, InStr(pos + 1, AData, " ") - pos - 1)
            Mode = Left(Mode, InStr(1, Mode, " ") - 1)
        End If
        
        OutPut.AddText "MODE: " & UName & " sets " & Mode & " on " & onc & CR, Val(getsetting("MLIRC", "Colors", "Mode", Str(&HFF&))), True
        If UCase(Left(Mode, 2)) = "-O" Or UCase(Left(Mode, 2)) = "-V" Then
            For i = 1 To Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems.Count
                If Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = "@" & onc Or Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = "+" & onc Then Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = Right(Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text, Len(Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text) - 1)
            Next i
        End If
        If UCase(Left(Mode, 2)) = "+O" Then
            For i = 1 To Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems.Count
                'debug.print Hosts(Host).Channels(UCase(chan)).Window.List1.ListItems(i).Text, onc
                If Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = onc Then Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = "@" & Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text
            Next i
        End If
        If UCase(Left(Mode, 2)) = "+V" Then
            For i = 1 To Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems.Count
                If Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = onc Then Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text = "+" & Hosts(Host).Channels(UCase(Chan)).Window.List1.ListItems(i).Text
            Next i
        End If
        If Val(getsetting("MLIRC", "Options", "show Mode in channel", "1")) = 1 Then
            For i = 1 To Hosts(Host).Channels.Count
                If UCase(Hosts(Host).Channels(i).Name) = UCase(Chan) Then
                    OldAddText Hosts(Host).Channels(i).Window.Text1, "MODE: " & UName & " sets " & Mode & " on " & onc & CR, Val(getsetting("MLIRC", "Colors", "Mode", Str(&HFF&))), True
                End If
            Next i
        End If
    End If
End Sub

Function ProcessCTCP(Wohin As Form, WorkData As String, User As String, Host As String)
    Dim Command As String, Soundfile As String, erg, FileName As String, UName As String
    If InStr(1, User, "!") Then
        UName = Left(User, InStr(1, User, "!") - 1)
    Else
        UName = User
    End If
        
    ' [ USERPROFILE email=plh+@pitt.edu phone= age=29 home=http:// sdes=]

    ProcessCTCP = False
    'debug.print "***CTCP:"; workdata

    If InStr(1, WorkData, " ") Then
        Command = UCase(Mid(WorkData, 2, InStr(2, WorkData, " ") - 2))
    Else
        Command = UCase(Mid(WorkData, 2, Len(WorkData) - 2))
    End If
    
    Select Case Command
    
    Case "PING"
        EventHappen "PING", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & WorkData & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Ping from " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True
        
    Case "VERSION"
        EventHappen "VERSION", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & Chr$(1) & "VERSION MLIRC V" & MLIRCVer & " (c) 1996 by Michael Lantzen (leahcim) lantzen@deltakonzept.de" & Chr$(1) & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Version request by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True

    Case "PAGE"
        EventHappen "PAGE", WorkData, User, "", Host
        Beep
        Wohin.AddText "-=> You have been paged by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :You have paged " & Hosts(Host).Nick & Chr$(10)
        ProcessCTCP = True

    Case "TIME"
        EventHappen "TIME", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & Chr$(1) & "TIME " & Now & Chr$(1) & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Time request by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True

    Case "CLIENTINFO"
        EventHappen "CLIENTINFO", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & Chr$(1) & "CLIENTINFO ACCEPT ACTION CLIENTINFO DCC FINGER PAGE PING RESUME SOUND TIME USERINFO VERSION" & Chr$(1) & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Clientinfo request by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True

    Case "FINGER"
        EventHappen "FINGER", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & Chr$(1) & "FINGER " & UI.RN & " (" & UI.EMail & ") Idle " & DateDiff("s", Now, Hosts(Host).Idle) & " seconds" & Chr$(1) & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Fingered by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True

    Case "USERINFO"
        EventHappen "USERINFO", WorkData, User, "", Host
        If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "NOTICE " & UName & " :" & Chr$(1) & "USERINFO " & UI.RN & " (" & UI.EMail & ") Idle " & DateDiff("s", Now, Hosts(Host).Idle) & " seconds" & Chr$(1) & Chr$(10) & Chr$(13)
        Wohin.AddText "-=> Userinfo request by " & UName & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        ProcessCTCP = True
    
    Case "ICONTOO"
        EventHappen "ICONTOO", WorkData, User, "", Host
        Wohin.AddText "[" & Mid(WorkData, 2, Len(WorkData) - 2) & "]" & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        
        IconForm.Label1.Caption = UName
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        If Left(WorkData, 1) = Chr$(34) Then
            IconForm.pname = Mid(WorkData, 2, InStr(2, WorkData, Chr$(34)) - 2)
            WorkData = Right(WorkData, Len(WorkData) - InStr(2, WorkData, Chr$(34)))
        Else
            IconForm.pname = Left(WorkData, InStr(1, WorkData, " ") - 1)
            WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        End If
        IconForm.plength = Val(Left(WorkData, InStr(1, WorkData, " ") - 1))
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        IconForm.pdate = Left(WorkData, Len(WorkData) - 1)
        IconForm.PNick = UName
        FileName = IconInCache(IconForm.pname, IconForm.plength, IconForm.pdate)
        If FileName = "" Then
'            If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "PRIVMSG " & uname & " :" & Chr$(1) & "ICONGET " & Trim(Str(IconForm.TCP1.LocalPort)) & " " & Trim(Str(IP2String(Hosts(Host).Window.TCP1.LocalIP))) & Chr$(1) & Chr$(10)
        Else
            IconForm.Picture1.Picture = LoadPicture(App.Path & "\icon\" & FileName)
            Beep
        End If
        
        ProcessCTCP = True
    
    Case "ICON"
        EventHappen "ICON", WorkData, User, "", Host
        Wohin.AddText "[" & Mid(WorkData, 2, Len(WorkData) - 2) & "]" & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        
        IconForm.Label1.Caption = UName
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        If Left(WorkData, 1) = Chr$(34) Then
            IconForm.pname = Mid(WorkData, 2, InStr(2, WorkData, Chr$(34)) - 2)
            WorkData = Right(WorkData, Len(WorkData) - InStr(2, WorkData, Chr$(34)))
        Else
            IconForm.pname = Left(WorkData, InStr(1, WorkData, " ") - 1)
            WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        End If
        IconForm.plength = Val(Left(WorkData, InStr(1, WorkData, " ") - 1))
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        IconForm.pdate = Left(WorkData, Len(WorkData) - 1)
        IconForm.PNick = UName
        FileName = IconInCache(IconForm.pname, IconForm.plength, IconForm.pdate)
        If FileName = "" Then
'            If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then Hosts(Host).SendData "PRIVMSG " & uname & " :" & Chr$(1) & "ICONGET " & Trim(Str(IconForm.TCP1.LocalPort)) & " " & Trim(Str(IP2String(Hosts(Host).Window.TCP1.LocalIP))) & Chr$(1) & Chr$(10)
        Else
            IconForm.Picture1.Picture = LoadPicture(App.Path & "\icon\" & FileName)
            Beep
        End If
        
        ProcessCTCP = True
    
        FileName = getsetting("MLIRC", "User", "MyPicture", "")
        Do While InStr(1, FileName, "\")
            FileName = Right(FileName, Len(FileName) - InStr(1, FileName, "\"))
        Loop
        If InStr(1, FileName, " ") Then FileName = Chr$(34) & FileName & Chr$(34)
        If FileName <> "" And Val(getsetting("MLIRC", "Options", "transfer Pictures", "0")) = 1 Then
            If Val(getsetting("MLIRC", "Options", "answer CTCP", "1")) = 1 Then CommandLine "/CTCP " & UName & " ICONTOO " & FileName & " " & FileLen(getsetting("MLIRC", "User", "MyPicture", "")) & " " & DateDiff("s", CVDate("01/01/1970"), FileDateTime(getsetting("MLIRC", "User", "MyPicture", ""))), Host, 0
        End If
    
    Case "ICONGET"
        Wohin.AddText WorkData & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&H8F&))), False
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
'        IconForm.TCP3.RemotePort = Val(Left(workdata, InStr(1, workdata, " ") - 1))
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
'        IconForm.TCP3.RemoteHost = String2IP(Left(workdata, Len(workdata) - 1))
        On Error GoTo cfehler
        IconForm.Label4.Caption = "connecting..."
'        IconForm.TCP3.Connect
        On Error GoTo 0
        ProcessCTCP = True
        
    Case "SOUND"
        EventHappen "SOUND", WorkData, User, "", Host
        WorkData = Right(WorkData, Len(WorkData) - InStr(1, WorkData, " "))
        If InStr(1, WorkData, " ") Then Soundfile = Left(WorkData, InStr(1, WorkData, " ") - 1)
        WorkData = Trim(Right(WorkData, Len(WorkData) - Len(Soundfile)))
        WorkData = Left(WorkData, Len(WorkData) - 1)
        Wohin.AddText "Sound request from " & UName & " " & Soundfile & " : " & WorkData & CR, &HFF&, False
        If Dir(Soundfile) <> "" Then
            erg = PlaySound(Soundfile, 0, SND_ASYN)
        End If
        If Dir(App.Path & "\" & Soundfile) <> "" Then
            erg = PlaySound(App.Path & "\" & Soundfile, 0, SND_ASYN)
        End If
        ProcessCTCP = True

    End Select
Exit Function

cfehler:
    If Err = 10048 Then
'        IconForm.TCP3.Close
'        IconForm.TCP3.LocalPort = IconForm.TCP3.LocalPort + 1
        Resume
    End If
    MsgBox (Err & " " & Error$)
    Resume Next
End Function


Sub RequestHost(Host As String)
    Dim IRCU As IRCUser, Channel As Integer

    LastRequest = ""
    
    For Channel = 1 To Hosts(Host).Channels.Count
        For Each IRCU In Hosts(Host).Channels(Channel).IRCUsers 'Update if there
            If IRCU.User = "" Then
                Hosts(Host).SendData "USERHOST " & IRCU.Nick & Chr$(10)
                LastRequest = IRCU.Nick
                IRCU.User = "?"
                'debug.print "Userhost request on: "; IRCU.Nick
                Exit Sub
            End If
        Next
    Next Channel
    LastRequest = ""
End Sub


Sub SendDCCFile(UName As String, FileName As String, Host As String)
    Host = UCase(Host)
    
    Dim i As Integer, IP As Double
    Dim ip1 As String, FLen As Double, FName As String
    
    IP = MDIForm1.IdentDL.LocalIP
    
    If Trim(FileName) = "" Then
        Dim fd As New FileDiag
        fd.UName.Text = UName
        fd.IP.Text = Trim(Str(IP))
        fd.Host.Text = Host
        fd.Label1.Caption = "Send to " & UName
        fd.Show
        Exit Sub
    End If
    
    If Dir(FileName) = "" Then
        Hosts(Host).Window.AddText "File not found : " & FileName & vbCrLf, &HFF&, True
        Exit Sub
    End If
    
    FName = FileName
    Do While InStr(1, FName, "\")
        FName = Right(FName, Len(FName) - InStr(1, FName, "\"))
    Loop
    FLen = FileLen(FileName)
    
    DCCts.Add NewDCCRecform, FName & " " & UName
            
    DCCts(FName & " " & UName).tfilenamel.Text = FileName
    DCCts(FName & " " & UName).tfilename.Text = FName
    DCCts(FName & " " & UName).tlength.Text = FLen
    DCCts(FName & " " & UName).tusername.Text = UName
    
    DCCts(FName & " " & UName).Tag = FName & " " & UName
    DCCts(FName & " " & UName).Caption = "DCC Send to " & UName
    DCCts(FName & " " & UName).DCCSock.LocalPort = 0
    DCCts(FName & " " & UName).DCCSock.Listen
    
    Hosts(Host).SendData "PRIVMSG " & UName & " :" & Chr$(1) & "DCC SEND " & FName & " " & Trim(Str(DCCts(FName & " " & UName).DCCSock.LocalIP)) & " " & Trim(Str(DCCts(FName & " " & UName).DCCSock.LocalPort)) & " " & Trim(Str(FLen)) & Chr$(1) & Chr$(10) & Chr$(13)
    
    DCCts(FName & " " & UName).Label1.Caption = "File: " & FName & " Size: " & FLen
    DCCts(FName & " " & UName).Label2.Caption = "Send request to " & UName & CR
    DCCts(FName & " " & UName).Show
End Sub

Function FindUser(UList As Control, UName As String)
    Dim i, UName2 As String
    
    FindUser = -1
    
    For i = 1 To UList.ListItems.Count
        UName2 = CutOp(UList.ListItems(i))
        If UCase(UName2) = UCase(UName) Then
            FindUser = i
            Exit For
        End If
    Next i
End Function

Sub GetServers()
    Dim i As Integer, stemp As String, pos As Integer
    i = 0
    
    Do While getsetting("MLIRC", "Servers", "SV" & Trim(Str(i)), "") <> ""
        stemp = getsetting("MLIRC", "Servers", "SV" & Trim(Str(i)))
        ReDim Preserve IRCServers(i)
        pos = InStr(1, stemp, "SERVER:")
        IRCServers(i).Name = Left(stemp, pos - 1)
        IRCServers(i).hostname = Mid(stemp, pos + 7, InStr(pos + 7, stemp, ":") - pos - 7)
        pos = InStr(pos + 7, stemp, ":") + 1
        If InStr(pos, stemp, "GROUP:") Then
            IRCServers(i).Port = Val(Mid(stemp, pos, InStr(pos, stemp, "GROUP:") - pos))
            pos = InStr(pos, stemp, "GROUP:") + 6
            IRCServers(i).Group = Mid(stemp, pos)
        Else
            IRCServers(i).Port = Val(Mid(stemp, pos))
        End If
        ServerCount = i
        i = i + 1
    Loop
End Sub

Function KB_Remain(starttime, received As Double)
    Dim diff As Double
    diff = DateDiff("s", starttime, Time)
    If diff > 0 Then
        KB_Remain = Str(received) & " " & "in " & diff & " Secs = " & Format((received / 1024&) / diff, "0.000") & "kb/Sec"
    End If
End Function


Function NewDCCChatForm()
    Dim DCCChat As New DCC_Chat
    Set NewDCCChatForm = DCCChat
End Function
Function NewDCCRecform()
    Dim DCCRec As New DCC_Send
    Set NewDCCRecform = DCCRec
End Function



Sub SaveServers()
    Dim i As Integer, n As Integer, Outs As String
    
    i = 0
    
    Do While getsetting("MLIRC", "Servers", "SV" & Trim(Str(i)), "") <> ""
        DeleteSetting "MLIRC", "Servers", "SV" & Trim(Str(i))
        i = i + 1
    Loop
    
    n = 0
    For i = 0 To ServerCount
        If Trim(IRCServers(i).Name & IRCServers(i).hostname) <> "" Then
            Outs = IRCServers(i).Name & "SERVER:" & IRCServers(i).hostname & ":" & IRCServers(i).Port
            If IRCServers(i).Group <> "" Then Outs = Outs & "GROUP:" & IRCServers(i).Group
            SaveSetting "MLIRC", "Servers", "SV" & Trim(Str(n)), Outs
            n = n + 1
        End If
    Next i
End Sub

Sub OpenNewChannel(Host As String, CName As String)
    Dim NewWin As New ChannelW
    Dim NewChannel As New IRCChannel
    Dim clmx As ColumnHeader
    Dim NC As Integer, pos As String

    CName = Trim(CName)
    
    NewChannel.Name = CName
    
    NewWin.Tag = Trim(Host & " " & UCase(CName))
    NewWin.Caption = Trim(CName)
    Set clmx = NewWin.List1.ColumnHeaders.Add(, , "Nick", NewWin.List1.Width * 0.6)
    Set clmx = NewWin.List1.ColumnHeaders.Add(, , "User", NewWin.List1.Width * 1.4)
    Set clmx = NewWin.List1.ColumnHeaders.Add(, , "RealName", NewWin.List1.Width)
    Set clmx = NewWin.List1.ColumnHeaders.Add(, , "Icon", 200)
    NewWin.List1.Icons = MDIForm1.ImageList1
    NewWin.List1.SmallIcons = MDIForm1.ImageList2
    NewWin.List1.View = 2
    NewWin.Show
    
    pos = getsetting("MLIRC", "WindowPos", UCase(CName), "")
    If pos <> "" Then
        NewWin.Top = Val(Left(pos, InStr(1, pos, " ") - 1))
        pos = Mid(pos, InStr(1, pos, " ") + 1)
        NewWin.Left = Val(Left(pos, InStr(1, pos, " ") - 1))
        pos = Mid(pos, InStr(1, pos, " ") + 1)
        NewWin.Width = Val(Left(pos, InStr(1, pos, " ") - 1))
        pos = Mid(pos, InStr(1, pos, " ") + 1)
        NewWin.Height = Val(Trim(pos))
    End If
    
    Set NewChannel.Window = NewWin
    Hosts(Host).Channels.Add NewChannel, UCase(CName)
End Sub

Sub SendCTCP(Name As String, WinHost As String, Command As String)
            WinHost = UCase(Trim(WinHost))
            
            If Left(Name, 1) = "@" Then Name = Right(Name, Len(Name) - 1)
            Hosts(WinHost).SendData "PRIVMSG " & Name & " :" & Chr$(1)
            Select Case UCase(Command)
            
            Case "PING"
                Hosts(WinHost).SendData "PING " & Trim(Str(DateDiff("s", CVDate("01/01/1970"), Now)))
                Hosts(WinHost).Window.AddText "! Ping to " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False
                
            Case "VERSION"
                Hosts(WinHost).SendData "VERSION"
                Hosts(WinHost).Window.AddText "! Version request on " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False
            
            Case "FINGER"
                Hosts(WinHost).SendData "FINGER"
                Hosts(WinHost).Window.AddText "! Finger " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False

            Case "PAGE"
                Hosts(WinHost).SendData "PAGE"
                Hosts(WinHost).Window.AddText "! Page " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False

            Case "USERINFO"
                Hosts(WinHost).SendData "USERINFO"
                Hosts(WinHost).Window.AddText "! Userinfo request on " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False

            Case "CLIENTINFO"
                Hosts(WinHost).SendData "CLIENTINFO"
                Hosts(WinHost).Window.AddText "! Clientinfo request on " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False

            Case "TIME"
                Hosts(WinHost).SendData "TIME"
                Hosts(WinHost).Window.AddText "! Time request to " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False

            Case Else
                Hosts(WinHost).SendData Command
                Hosts(WinHost).Window.AddText Command & " -> " & Name & CR, Val(getsetting("MLIRC", "Colors", "CTCP request", Str(&HFF0000))), False
                
            End Select
            Hosts(WinHost).SendData Chr$(1) & Chr$(10) & Chr$(13)
End Sub



Function String2IP(IP As Double)
    Dim IPstring As String, ip1 As Double
    
    ip1 = Int(IP / 16777216)
    IPstring = ip1 & "."
    IP = IP - Int(ip1 * 16777216)
    ip1 = Int(IP / 65536)
    IPstring = IPstring & ip1 & "."
    IP = IP - Int(ip1 * 65536)
    ip1 = Int(IP / 256)
    IPstring = IPstring & ip1 & "."
    IP = IP - Int(ip1 * 256)
    String2IP = IPstring & Int(IP)
End Function


